* MOVE_MEMORY source TO destination,bytes
* QLiberator assembler directive is:
* $$asmb=FLPn_MOVEMEM_cde,0,12

        lea     procdef,a1
        move.w  $110,a0
        jsr     (a0)
        rts

procdef dc.w    2,entry3-*
        dc.b    11,'MOVE_MEMORY'
        dc.w    0,0,0

* MOVEMEM source,destination,bytes
* source and destination addresses to be even
* bytes to move to be even (odd byte at end of block ignored)

entry3  movea.w $118,a2         ;CA.GTLIN
        jsr     (a2)            ;get all FP parameters as long integers
        bne.s   return          ;oops, error return to basic
        moveq   #-15,d0         ;anticipate err_bp
        cmpi.w  #3,d3           ;3 parameters?
        beq.s   ok1             ;yes, continue
return  rts                     ;back to basic
ok1     move.l  0(a6,a1.l),a2   ;a2=source address
        move.l  4(a6,a1.l),a3   ;a3=destination address
        move.l  8(a6,a1.l),d1   ;d1=bytes to move
        move.l  a2,d2           ;d2=source
        btst    #0,d2           ;even source address?
        bne.s   return          ;oops, no, err_bp
        move.l  a3,d3           ;d3=destination
        btst    #0,d3           ;even destination address?
        bne.s   return          ;oops, no, err_bp
        clr.l   d0              ;no errors from here on...!
        lsr.w   #1,d1           ;d1=d1 DIV 2 (no. of words to move)
        cmpi.w  #1,d1           ;less than 1 word to move?
        blt.s   return          ;abort before loop is executed
        subq.w  #1,d1           ;prepare for dbf d1...
loop2   move.w  (a2)+,(a3)+     ;transfer word of memory...
        dbf     d1,loop2        ;...until end of block
        rts                     ;back to basic
